/*******************************************
 * soubor str-arry.c
 * ze standardniho vstupu cte radky, alokuje
 * pro ne pamet a ukazatele na tuto kopii
 * nacteneho radku uklada do pole ukazatelu
 * pole ukazatelu ma pocatecni velikost, ktera
 * se ovsem v pripade potreby zmeni - realloc()
 * po ukonceni vstupu nactene radky vytiskne
 *******************************************/

/*************************
 * obvykle navratove hodnoty
 * 	O.K.	0
 *	error	!0 (casto -1)
 *************************/

#include <stdio.h>
#include <string.h>

#define	START		20
#define	PRIRUSTEK	20
#define	DELKA_RADKU	100

typedef char * 	  retezec;
typedef retezec * pole_retezcu;

int alokace(pole_retezcu *p_r, int pocet)
/* alokuje pole retezcu */
{
 *p_r = (char **) malloc(pocet * sizeof(retezec));
 return (*p_r == NULL) ? -1 : 0;
} /* alokace */

int re_alokace(pole_retezcu *p_r, int novy_pocet)
/* no noveho pole nakopiruje puvodni ukazatele
 * pak puvodni pole zrusi */
{
 pole_retezcu pom;
 if (*p_r == NULL)
   {
    /* poprve proste neni co realokovat
     * takze "jen" alokace */
    if (alokace(p_r, novy_pocet))
      /* chyba, nepovedlo se */
      return -1;
   }
 else
   {
    /* ted uz realokace */
    pom = (char **) realloc(*p_r,
                 sizeof(retezec) * novy_pocet);
    if (pom == NULL)
      /* neuspech - navratovy kod -1 */
      return -1;
    /* uspech, ted nezapomenout predat nove pole!!! */
    *p_r = pom;
   }
 return 0;
} /* re_alokace */

int pridej_radek(pole_retezcu *p_r, retezec s, int index)
/* vyalokuje pamet a umisti do ni kopii radku
 * to vse v ramci jednoho z prvku pole ukazatelu */
{
 int delka = strlen(s) + 1;
 if (((*p_r)[index] = (char *) malloc(delka)) == NULL)
   return -1;
 strcpy((*p_r)[index], s);
 return 0;
} /* pridej_radek */

int cti_a_pridavej(pole_retezcu *p_r, int *pocet,
                   int *alokovano, int prir)
/* cte radky dokud neni konec vstupu
 * pridava je do pole ukazatelu     */
{
 char radek[DELKA_RADKU], *pom;
 fputs("Zadavej retezce, posledni CTRL-Z"
       " na novem radku\n", stderr);
 /* takze cteme */
 do
   {
    if ((pom = gets(radek)) != NULL)
      {
      /* nacten dalsi radek */
       if (*pocet + 1 > *alokovano)
         /* zatim neni pro nej misto */
	 {
          /* zvetsime pole ukazatelu */
	  if (re_alokace(p_r, *alokovano + prir))
	    {
	     puts("nedostatek pameti");
	     return -1;
	    }
	  *alokovano += prir;
          /* a poznamename si jeho novou velikost */
	 }
       if (pridej_radek(p_r, radek, *pocet))
	 {
          /* s pridamim radku jsme neuspeli */
	  puts("nedostatek pameti");
	  return 1;
	 }
       /* v poradku, je tam o radek vic */
       (*pocet)++;
      }
   } while (pom != NULL);
   /* tedy dokud je neco na vstupu */
 return 0;
} /* cti_a_pridavej */


void zobrazuj(pole_retezcu p_r, int pocet)
 /* vytiskne vsechny nactne radky
  * tedy prvky pole */
{
 while (pocet--)
 /* je jich pocet, tak ho po kazdem
  * vystupu musime snizit */
   {
    puts(*p_r++);
    /* ukazatel v poli musime naopak
     * posunout na dalsi retezec */
   }
} /* zobrazuj */

int main(void)
{
 int	pocet	  = 0,
	alokovano = START,
	prirustek = PRIRUSTEK;
 pole_retezcu p_ret = NULL;

 if (alokace(&p_ret, alokovano))
   {
    puts("nedostatek pameti");
    return 1;
   }
 if (cti_a_pridavej(&p_ret, &pocet, &alokovano, prirustek))
   return 1;
 zobrazuj(p_ret, pocet);

 return 0;
} /* main */
